proc CreateSTLObject { name fileName } {

    set pFile [open $fileName "r"]
    if { $pFile == 0 } {
	error "ERROR: unable to open \"$fileName\""
    }

    set lFile [read $pFile]

    set lPoints {}
    set lFaces {}
    set uiPoint 0
    set uiFace 0
    set pcPointBase "p$name"
    set pcFaceBase "f$name"
    set pcObject "o$name"

    set i 0
    if { [lindex $lFile $i] != "solid" } {
	close $pFile
	error "ERROR \"$fileName\": encountered \"[lindex $lFile $i]\" when expecting \"solid\""
    }
    incr i
    if { [lindex $lFile $i] != "facet" } {
	incr i
    }

    while { $i < [llength $lFile] } {
	if { [lindex $lFile $i] == "endsolid" } {
	    slide create object $pcObject $lFaces
	    close $pFile
	    return $pcObject
	} elseif { [lindex $lFile $i] != "facet" } {
	    close $pFile
	    error "ERROR \"$fileName\": facet $uiface: encountered \"[lindex $lFile $i]\" when expecting \"facet\""
	}
	incr i
	if { [lindex $lFile $i] != "normal" } {
	    close $pFile
	    error "ERROR \"$fileName\": facet $uiface: encountered \"[lindex $lFile $i]\" when expecting \"normal\""
	}
	incr i
	
	# the normal
	incr i 3

	if { [lindex $lFile $i] != "outer" } {
	    close $pFile
	    error "ERROR \"$fileName\": facet $uiface: encountered \"[lindex $lFile $i]\" when expecting \"outer\""
	}
	incr i
	if { [lindex $lFile $i] != "loop" } {
	    close $pFile
	    error "ERROR \"$fileName\": facet $uiface: encountered \"[lindex $lFile $i]\" when expecting \"loop\""
	}
	incr i

	set lPoints {}
	for { set j 0 } { $j < 3 } { incr j } {
	    if { [lindex $lFile $i] != "vertex" } {
		close $pFile
		error "ERROR \"$fileName\": facet $uiface: encountered \"[lindex $lFile $i]\" when expecting \"vertex\""
	    }
	    incr i
	    
	    slide create point ${pcPointBase}${uiPoint} [lrange $lFile $i [expr $i + 2]]
	    incr i 3

	    lappend lPoints "${pcPointBase}${uiPoint}"
	    incr uiPoint
	}

	if { [lindex $lFile $i] != "endloop" } {
	    close $pFile
	    error "ERROR \"$fileName\": facet $uiface: encountered \"[lindex $lFile $i]\" when expecting \"endloop\""
	}
	incr i
	if { [lindex $lFile $i] != "endfacet" } {
	    close $pFile
	    error "ERROR \"$fileName\": facet $uiface: encountered \"[lindex $lFile $i]\" when expecting \"endfacet\""
	}
	incr i

	slide create face ${pcFaceBase}${uiFace} $lPoints
	lappend lFaces "${pcFaceBase}${uiFace}"
	incr uiFace
    }

    close $pFile
    error "ERROR \"$fileName\": facet $uiface: unexpected end of file"
}
